﻿; MC Media Checker: 160303
; Author: jmone Thread on Interact: http://yabb.jriver.com/interact/index.php?topic=103555.0

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
#SingleInstance ignore
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
#MaxMem 256

;============= Set Vars and Check Runtime Mode ===========================
IniRead, MC_WS, MC Media Checker.ini,MC_Settings,MC_WS
IniRead, MC_UserName, MC Media Checker.ini,MC_Settings,MC_UserName
IniRead, MC_Password, MC Media Checker.ini,MC_Settings,MC_Password

;============= Initialise and Setup Menu===========================
if !FileExist("MC Media Checker.ini")
  {
  Gui, Add, Text,x10 y10,Setup MC Media Checker and Configure MC21 for the First Time:
  Gui, Add, Edit, x40 y30 w130 h20 vMC_WS, 127.0.0.1:52199
  Gui, Add, Text,x180 y30,<--- Enter MCWS Server Address:Port
  Gui, Add, Edit, x40 y60 w130 h20 vMC_UserName, username
  Gui, Add, Text,x180 y60,<--- Enter MCWS Username
  Gui, Add, Edit, x40 y90 w130 h20 vMC_Password, password
  Gui, Add, Text,x180 y90,<--- Enter MCWS Password
  Gui, Add, Button, x40 y120 w130 h20, Test
  gui, add, text, x10 y150 w400 0x10
  Gui, Add, Button, x40 y160 w130 h20, Save
  Gui, Add, Button, x250 y160 w130 h20, Cancel
  Gui, Show,,MC Media Checker Installer
  Return
;---------- CheckMC and User Settings ----------------
  ButtonTest:
    Gui, Submit, NoHide
    guiControlGet, UserInput
    Progress, b1 w300, Checking for Media Center at %MC_WS%`n Please Wait
    sleep, 1000
    MC_Call = http://%MC_WS%/MCWS/v1/Authenticate
    GoSub, MCWS
    Progress, off
    If Status = 200 
      MsgBox, All OK!
  Return
;---------- Make INI and Registry Changes ----------------
  ButtonSave:
    Gui, Submit, NoHide
    guiControlGet, UserInput
    IniWrite, %MC_WS%, MC Media Checker.ini,MC_Settings,MC_WS
    IniWrite, %MC_UserName%, MC Media Checker.ini,MC_Settings,MC_UserName
    IniWrite, %MC_Password%, MC Media Checker.ini,MC_Settings,MC_Password
    gosub, Script_End
  }

;============= Main Menu ================================
Gui, Add, Text,x10, Select Folder to check against MC's Library
Gui, Add, Button, x10 y30 w200 h40 gButtonReadInfo, Open Folder
Gui, Add, Text,x10 y90 w410 h10 0x10
Gui, Add, Text,x10 y100, File being checked:
Gui, Add, Text, vToShow W400 H50
Gui, Add, Button, default x140 y200 w150 h25, Cancel
Gui, Show,,MC Media Checker Menu

Return
;============= Process Choice =============
ButtonReadInfo:
  GuiControl, disable, gButtonReadInfo
  FileSelectFolder, Folder
  If Folder =
    gosub, Script_End

  FileList =
  Loop Files, %Folder%\*.*, R  ; Recurse into subfolders.
  {
    TempData = %A_LoopFileFullPath%

    GuiControl,,ToShow,%A_LoopFileFullPath%

    TempData = % UrlEncode(TempData)
    MC_Call = http://%MC_WS%/MCWS/v1/File/GetInfo?File=%TempData%&FileType=Filename
    GoSub, MCWS

    If Status = 500 
      fileappend, %A_LoopFileFullPath%`n`r, FileList.txt
  }

gosub, Script_End

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++ FUNCTIONS and SUBS ++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;-------------MCWS---------------------------
MCWS:
  WinHTTP := ComObjCreate("WinHTTP.WinHttpRequest.5.1")
  ComObjError(false)
  WinHTTP.Open("GET", MC_Call)
  WinHTTP.SetCredentials(MC_UserName,MC_Password,0)
  WinHTTP.SetRequestHeader("Content-type", "application/x-www-form-urlencoded")
  Body = ""
  WinHTTP.Send(Body)
  Result := WinHTTP.ResponseText
  Status := WinHTTP.Status

  If Status = 200 
    Return
  If Status = 500 
    Return
  Else 
    {
    Progress, off
    If !Status
      msgbox, Error - MediaCenter not Found at %MC_WS%
    Else
      If Status = 401
        msgbox, Error 401 Access Denied - Check Username / Password
      Else
        msgbox, Error - %Status%  Processed Failed (see details below)`n%MC_Call%`n%Result%
    }
Return


; ----------URL Encode -------------------------------------------------------------------------------------------------------------
; Thanks to users at - http://www.autohotkey.com/board/topic/35660-url-encoding-function/#entry224694
UrlEncode( String )
{
	OldFormat := A_FormatInteger
	SetFormat, Integer, H

	Loop, Parse, String
	{
		if A_LoopField is alnum
		{
			Out .= A_LoopField
			continue
		}
		Hex := SubStr( Asc( A_LoopField ), 3 )
		Out .= "%" . ( StrLen( Hex ) = 1 ? "0" . Hex : Hex )
	}

	SetFormat, Integer, %OldFormat%
        Out = %Out%
	return Out
}

;note Out = %Out% replaces Out = "%Out%" as the MCWS search does not like the quoting of the string

;=================== APP END ACTIONS ==========================
ButtonCancel:
GuiClose:
GuiEscape:
Script_End:
Gui, Hide
FileDelete, temp.chapters.txt
Progress, Off
;msgbox Finished
exitapp
